DevExtreme v26.1 is now available.

Explore our newest features/capabilities and share your thoughts with us.

Your search did not match any results.

JavaScript/jQuery Data Grid - Advanced Master-Detail View

This demo illustrates an advanced master-detail view in the JavaScript DataGrid component. Master rows represent suppliers. Detail sections contain TabPanel components with two tabs: Orders and Address. In the Orders tab, you can choose a supplier's product from the SelectBox, and the JavaScript DataGrid under it will show orders placed on this product. The Address tab displays the supplier's address.

Backend API
const url = 'https://js.devexpress.com/Demos/NetCore/api/DataGridAdvancedMasterDetailView'; $(() => { $('#gridContainer').dxDataGrid({ showBorders: true, dataSource: DevExpress.data.AspNet.createStore({ key: 'SupplierID', loadUrl: `${url}/GetSuppliers`, }), paging: { pageSize: 15, }, pager: { visible: true, }, remoteOperations: true, columns: [ 'ContactName', 'ContactTitle', 'CompanyName', 'City', 'Country', ], masterDetail: { enabled: true, template: masterDetailTemplate, }, }); }); function masterDetailTemplate(_, masterDetailOptions) { return $('<div>').dxTabPanel({ items: [{ title: 'Orders', template: createOrdersTabTemplate(masterDetailOptions.data), }, { title: 'Address', template: createAddressTabTemplate(masterDetailOptions.data), }], }); } function createOrdersTabTemplate(masterDetailData) { return () => { let orderHistoryDataGrid; function onProductChanged(productID) { orderHistoryDataGrid.option('dataSource', createOrderHistoryStore(productID)); } function onDataGridInitialized(e) { orderHistoryDataGrid = e.component; } return $('<div>').addClass('form-container').dxForm({ labelLocation: 'top', items: [{ label: { text: 'Product' }, template: createProductSelectBoxTemplate(masterDetailData, onProductChanged), }, { label: { text: 'Order History' }, template: createOrderHistoryTemplate(onDataGridInitialized), }], }); }; } function createProductSelectBoxTemplate(masterDetailData, onProductChanged) { return () => $('<div>').dxSelectBox({ inputAttr: { 'aria-label': 'Product' }, dataSource: DevExpress.data.AspNet.createStore({ key: 'ProductID', loadParams: { SupplierID: masterDetailData.SupplierID }, loadUrl: `${url}/GetProductsBySupplier`, }), valueExpr: 'ProductID', displayExpr: 'ProductName', deferRendering: false, onContentReady(e) { const firstItem = e.component.option('items[0]'); if (firstItem) { e.component.option('value', firstItem.ProductID); } }, onValueChanged(e) { onProductChanged(e.value); }, }); } function createOrderHistoryTemplate(onDataGridInitialized) { return () => $('<div>').dxDataGrid({ onInitialized: onDataGridInitialized, paging: { pageSize: 5, }, showBorders: true, columns: [ 'OrderID', { dataField: 'OrderDate', dataType: 'date', }, 'ShipCountry', 'ShipCity', { dataField: 'UnitPrice', format: 'currency', }, 'Quantity', { dataField: 'Discount', format: 'percent', }, ], summary: { totalItems: [{ column: 'UnitPrice', summaryType: 'sum', valueFormat: { format: 'currency', precision: 2, }, }, { column: 'Quantity', summaryType: 'count', }], }, }); } function createAddressTabTemplate(data) { return () => $('<div>').addClass('address-form form-container').dxForm({ formData: data, colCount: 2, customizeItem(item) { item.template = formItemTemplate; }, items: ['Address', 'City', 'Region', 'PostalCode', 'Country', 'Phone'], }); } function formItemTemplate(item) { return $('<span>').text(item.editorOptions.value); } function createOrderHistoryStore(productID) { return DevExpress.data.AspNet.createStore({ key: 'OrderID', loadParams: { ProductID: productID }, loadUrl: `${url}/GetOrdersByProduct`, }); }
<!DOCTYPE html> <html xmlns="http://www.w3.org/1999/xhtml" lang="en"> <head> <title>DevExtreme Demo</title> <meta http-equiv="X-UA-Compatible" content="IE=edge" /> <meta http-equiv="Content-Type" content="text/html; charset=utf-8" /> <meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" /> <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script> <script>window.jQuery || document.write(decodeURIComponent('%3Cscript src="js/jquery.min.js"%3E%3C/script%3E'))</script> <link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.4/css/dx.light.css" /> <link rel="stylesheet" type="text/css" href="styles.css" /> <script src="js/dx.all.js?v=26.1.4"></script> <script src="https://unpkg.com/devextreme-aspnet-data@5.0.0/js/dx.aspnet.data.js"></script> <script src="index.js"></script> </head> <body class="dx-viewport"> <div class="demo-container"> <div id="gridContainer"></div> </div> </body> </html>
#gridContainer { height: 620px; } .dx-datagrid-rowsview .dx-master-detail-row:not(.dx-datagrid-edit-form) > .dx-datagrid-group-space, .dx-datagrid-rowsview .dx-master-detail-row:not(.dx-datagrid-edit-form) .dx-master-detail-cell { background-color: transparent; } .form-container { padding: 20px; } .address-form label { font-weight: bold; }

Backend API
import React from 'react';
import {
Column, DataGrid, MasterDetail, Paging, Pager,
} from 'devextreme-react/data-grid';
import { createStore } from 'devextreme-aspnet-data-nojquery';
import MasterDetailView from './MasterDetailView.tsx';
const url = 'https://js.devexpress.com/Demos/NetCore/api/DataGridAdvancedMasterDetailView';
const suppliersData = createStore({
key: 'SupplierID',
loadUrl: `${url}/GetSuppliers`,
});
const App = () => (
<DataGrid
dataSource={suppliersData}
remoteOperations={true}
showBorders={true}
id="gridContainer"
>
<MasterDetail
enabled={true}
component={MasterDetailView}
/>
<Paging defaultPageSize={15} />
<Pager visible={true} />
<Column dataField="ContactName" />
<Column dataField="ContactTitle" />
<Column dataField="CompanyName" />
<Column dataField="City" />
<Column dataField="Country" />
</DataGrid>
);
export default App;
import React from 'react';
import {
Column, DataGrid, MasterDetail, Paging, Pager,
} from 'devextreme-react/data-grid';
import { createStore } from 'devextreme-aspnet-data-nojquery';
import MasterDetailView from './MasterDetailView.js';
const url = 'https://js.devexpress.com/Demos/NetCore/api/DataGridAdvancedMasterDetailView';
const suppliersData = createStore({
key: 'SupplierID',
loadUrl: `${url}/GetSuppliers`,
});
const App = () => (
<DataGrid
dataSource={suppliersData}
remoteOperations={true}
showBorders={true}
id="gridContainer"
>
<MasterDetail
enabled={true}
component={MasterDetailView}
/>
<Paging defaultPageSize={15} />
<Pager visible={true} />
<Column dataField="ContactName" />
<Column dataField="ContactTitle" />
<Column dataField="CompanyName" />
<Column dataField="City" />
<Column dataField="Country" />
</DataGrid>
);
export default App;
import React from 'react';
import { Form, Item } from 'devextreme-react/form';
import type { TextBoxTypes } from 'devextreme-react/text-box';
const items = ['Address', 'City', 'Region', 'PostalCode', 'Country', 'Phone'];
interface FormItemRenderData {
editorOptions: TextBoxTypes.Properties;
}
const renderFormItem = (item: FormItemRenderData) => (
<span>{item.editorOptions.value}</span>
);
interface AddressTabProps {
data: any;
}
const AddressTab = (props: AddressTabProps) => (
<Form
formData={props.data}
colCount={2}
className="address-form form-container"
>
{
items.map((item, index) => <Item
dataField={item}
key={index}
render={renderFormItem}
/>)
}
</Form>
);
export default AddressTab;
import React, { useCallback } from 'react';
import type { DataGridTypes } from 'devextreme-react/data-grid';
import { TabPanel, Item } from 'devextreme-react/tab-panel';
import AddressTab from './AddressTab.tsx';
import OrdersTab from './OrdersTab.tsx';
const MasterDetailView = (props: DataGridTypes.MasterDetailTemplateData) => {
const renderOrdersTab = useCallback(() => (
<OrdersTab supplierId={props.data.key} />
), [props.data.key]);
const renderAddressTab = useCallback(() => (
<AddressTab data={props.data.data} />
), [props.data.data]);
return (
<TabPanel>
<Item title="Orders" render={renderOrdersTab} />
<Item title="Address" render={renderAddressTab} />
</TabPanel>
);
};
export default MasterDetailView;
import React, { useEffect, useState } from 'react';
import type { CustomStore } from 'devextreme-react/common/data';
import {
Column, DataGrid, Paging, Summary, TotalItem, ValueFormat,
} from 'devextreme-react/data-grid';
import { createStore } from 'devextreme-aspnet-data-nojquery';
const url = 'https://js.devexpress.com/Demos/NetCore/api/DataGridAdvancedMasterDetailView';
interface OrderHistoryProps {
productId: any;
}
const OrderHistory = ({ productId }: OrderHistoryProps) => {
const [orderHistoryStore, setOrderHistoryStore] = useState<CustomStore | undefined>(undefined);
useEffect(() => {
if (productId) {
const newOrderHistoryStore = createStore({
key: 'OrderID',
loadParams: { ProductID: productId },
loadUrl: `${url}/GetOrdersByProduct`,
});
setOrderHistoryStore(newOrderHistoryStore);
}
}, [productId]);
return (
<DataGrid
dataSource={orderHistoryStore}
showBorders={true}
>
<Paging defaultPageSize={5} />
<Column dataField="OrderID" />
<Column dataField="OrderDate" dataType="date" />
<Column dataField="ShipCountry" />
<Column dataField="ShipCity" />
<Column dataField="UnitPrice" format="currency" />
<Column dataField="Quantity" />
<Column dataField="Discount" format="percent" />
<Summary>
<TotalItem column="UnitPrice" summaryType="sum">
<ValueFormat precision={2} />
</TotalItem>
<TotalItem column="Quantity" summaryType="count" />
</Summary>
</DataGrid>
);
};
export default OrderHistory;
import React, { useCallback, useState } from 'react';
import { Form, Item, Label } from 'devextreme-react/form';
import ProductSelectBox from './ProductSelectBox.tsx';
import OrderHistory from './OrderHistory.tsx';
interface OrdersTabProps {
supplierId: any;
}
const OrdersTab = (props: OrdersTabProps) => {
const [chosenProductId, setChosenProductId] = useState(null);
const renderSelectBox = useCallback(() => (
<ProductSelectBox
supplierId={props.supplierId}
productId={chosenProductId}
onProductChanged={setChosenProductId} />
), [chosenProductId, props.supplierId]);
const renderOrderHistory = useCallback(() => (
<OrderHistory productId={chosenProductId} />
), [chosenProductId]);
return (
<Form
labelLocation="top"
className="form-container"
>
<Item render={renderSelectBox}>
<Label text="Product" />
</Item>
<Item render={renderOrderHistory}>
<Label text="Order History" />
</Item>
</Form>
);
};
export default OrdersTab;
import React, { useCallback, useEffect, useState } from 'react';
import type { CustomStore } from 'devextreme-react/common/data';
import { SelectBox } from 'devextreme-react/select-box';
import type { SelectBoxTypes } from 'devextreme-react/select-box';
import { createStore } from 'devextreme-aspnet-data-nojquery';
const url = 'https://js.devexpress.com/Demos/NetCore/api/DataGridAdvancedMasterDetailView';
const productLabel = { 'aria-label': 'Product' };
interface ProductSelectBoxProps {
supplierId: any;
productId: any;
onProductChanged: any;
}
const ProductSelectBox = (props: ProductSelectBoxProps) => {
const [productsData, setProductsData] = useState<CustomStore | null>(null);
const valueChanged = useCallback((e: SelectBoxTypes.ValueChangedEvent) => {
props.onProductChanged(e.value);
}, [props]);
useEffect(() => {
const setDefaultValue = (items: any[]) => {
const firstItem = items[0];
if (firstItem && props.productId === null) {
props.onProductChanged(firstItem.ProductID);
}
};
const newProductsData = createStore({
key: 'ProductID',
loadParams: { SupplierID: props.supplierId },
loadUrl: `${url}/GetProductsBySupplier`,
onLoaded: setDefaultValue,
});
setProductsData(newProductsData);
}, [props]);
return (
<SelectBox
value={props.productId}
deferRendering={false}
inputAttr={productLabel}
dataSource={productsData}
valueExpr="ProductID"
displayExpr="ProductName"
onValueChanged={valueChanged}
/>
);
};
export default ProductSelectBox;
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.tsx';
ReactDOM.render(
<App />,
document.getElementById('app'),
);
window.exports = window.exports || {};
window.config = {
transpiler: false,
meta: {
'*.ts': {
loader: 'demo-ts-loader',
},
'*.tsx': {
loader: 'demo-ts-loader',
typescriptOptions: {
jsx: 'react',
},
},
'typescript': {
'exports': 'ts',
},
'anti-forgery': {
loader: 'demo-ts-loader',
},
'react': {
'esModule': true,
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'devextreme-aspnet-data-nojquery': {
'esModule': true,
},
'openai': {
'esModule': true,
},
'zod': {
'esModule': true,
},
'zod-to-json-schema': {
'esModule': true,
},
},
paths: {
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
'loaders:': '../../../../shared/loaders/',
},
defaultExtension: 'js',
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'demo-ts-loader': 'loaders:demo-ts-loader.js',
'demo-ts-shared': 'loaders:demo-ts-shared.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
'react': 'npm:react@17.0.2/umd/react.development.js',
'react-dom': 'npm:react-dom@17.0.2/umd/react-dom.development.js',
'prop-types': 'npm:prop-types/prop-types.js',
'devextreme-aspnet-data-nojquery': 'npm:devextreme-aspnet-data-nojquery@5.1.0/index.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-react': 'npm:devextreme-react@link:../../packages/devextreme-react/npm/cjs',
'zod': 'externals:zod.bundle.js',
'zod-to-json-schema': 'externals:zod-to-json-schema.bundle.js',
'devextreme-quill': 'npm:devextreme-quill@1.7.10/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.69/dist/dx-gantt.js',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.4/dist/signals-core.min.js',
'devextreme-cldr-data': 'npm:devextreme-cldr-data@1.0.3',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
},
packages: {
'devextreme': {
defaultExtension: 'js',
},
'devextreme-react': {
main: 'index.js',
},
'devextreme-react/common': {
main: 'index.js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/localization/messages': {
format: 'json',
defaultExtension: 'json',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
],
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"zod": {
"version": "3.24.4"
},
"zod-to-json-schema": {
"version": "3.24.6"
}
};
import React from 'react';
import { Form, Item } from 'devextreme-react/form';
const items = ['Address', 'City', 'Region', 'PostalCode', 'Country', 'Phone'];
const renderFormItem = (item) => <span>{item.editorOptions.value}</span>;
const AddressTab = (props) => (
<Form
formData={props.data}
colCount={2}
className="address-form form-container"
>
{items.map((item, index) => (
<Item
dataField={item}
key={index}
render={renderFormItem}
/>
))}
</Form>
);
export default AddressTab;
import React, { useCallback } from 'react';
import { TabPanel, Item } from 'devextreme-react/tab-panel';
import AddressTab from './AddressTab.js';
import OrdersTab from './OrdersTab.js';
const MasterDetailView = (props) => {
const renderOrdersTab = useCallback(
() => <OrdersTab supplierId={props.data.key} />,
[props.data.key],
);
const renderAddressTab = useCallback(
() => <AddressTab data={props.data.data} />,
[props.data.data],
);
return (
<TabPanel>
<Item
title="Orders"
render={renderOrdersTab}
/>
<Item
title="Address"
render={renderAddressTab}
/>
</TabPanel>
);
};
export default MasterDetailView;
import React, { useEffect, useState } from 'react';
import {
Column,
DataGrid,
Paging,
Summary,
TotalItem,
ValueFormat,
} from 'devextreme-react/data-grid';
import { createStore } from 'devextreme-aspnet-data-nojquery';
const url = 'https://js.devexpress.com/Demos/NetCore/api/DataGridAdvancedMasterDetailView';
const OrderHistory = ({ productId }) => {
const [orderHistoryStore, setOrderHistoryStore] = useState(undefined);
useEffect(() => {
if (productId) {
const newOrderHistoryStore = createStore({
key: 'OrderID',
loadParams: { ProductID: productId },
loadUrl: `${url}/GetOrdersByProduct`,
});
setOrderHistoryStore(newOrderHistoryStore);
}
}, [productId]);
return (
<DataGrid
dataSource={orderHistoryStore}
showBorders={true}
>
<Paging defaultPageSize={5} />
<Column dataField="OrderID" />
<Column
dataField="OrderDate"
dataType="date"
/>
<Column dataField="ShipCountry" />
<Column dataField="ShipCity" />
<Column
dataField="UnitPrice"
format="currency"
/>
<Column dataField="Quantity" />
<Column
dataField="Discount"
format="percent"
/>
<Summary>
<TotalItem
column="UnitPrice"
summaryType="sum"
>
<ValueFormat precision={2} />
</TotalItem>
<TotalItem
column="Quantity"
summaryType="count"
/>
</Summary>
</DataGrid>
);
};
export default OrderHistory;
import React, { useCallback, useState } from 'react';
import { Form, Item, Label } from 'devextreme-react/form';
import ProductSelectBox from './ProductSelectBox.js';
import OrderHistory from './OrderHistory.js';
const OrdersTab = (props) => {
const [chosenProductId, setChosenProductId] = useState(null);
const renderSelectBox = useCallback(
() => (
<ProductSelectBox
supplierId={props.supplierId}
productId={chosenProductId}
onProductChanged={setChosenProductId}
/>
),
[chosenProductId, props.supplierId],
);
const renderOrderHistory = useCallback(
() => <OrderHistory productId={chosenProductId} />,
[chosenProductId],
);
return (
<Form
labelLocation="top"
className="form-container"
>
<Item render={renderSelectBox}>
<Label text="Product" />
</Item>
<Item render={renderOrderHistory}>
<Label text="Order History" />
</Item>
</Form>
);
};
export default OrdersTab;
import React, { useCallback, useEffect, useState } from 'react';
import { SelectBox } from 'devextreme-react/select-box';
import { createStore } from 'devextreme-aspnet-data-nojquery';
const url = 'https://js.devexpress.com/Demos/NetCore/api/DataGridAdvancedMasterDetailView';
const productLabel = { 'aria-label': 'Product' };
const ProductSelectBox = (props) => {
const [productsData, setProductsData] = useState(null);
const valueChanged = useCallback(
(e) => {
props.onProductChanged(e.value);
},
[props],
);
useEffect(() => {
const setDefaultValue = (items) => {
const firstItem = items[0];
if (firstItem && props.productId === null) {
props.onProductChanged(firstItem.ProductID);
}
};
const newProductsData = createStore({
key: 'ProductID',
loadParams: { SupplierID: props.supplierId },
loadUrl: `${url}/GetProductsBySupplier`,
onLoaded: setDefaultValue,
});
setProductsData(newProductsData);
}, [props]);
return (
<SelectBox
value={props.productId}
deferRendering={false}
inputAttr={productLabel}
dataSource={productsData}
valueExpr="ProductID"
displayExpr="ProductName"
onValueChanged={valueChanged}
/>
);
};
export default ProductSelectBox;
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.js';
ReactDOM.render(<App />, document.getElementById('app'));
<!DOCTYPE html>
<html lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.4/css/dx.light.css" />
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.tsx");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"></div>
</div>
</body>
</html>
#gridContainer {
height: 620px;
}
.dx-datagrid-rowsview .dx-master-detail-row:not(.dx-datagrid-edit-form) > .dx-datagrid-group-space,
.dx-datagrid-rowsview .dx-master-detail-row:not(.dx-datagrid-edit-form) .dx-master-detail-cell {
background-color: transparent;
}
.form-container {
padding: 20px;
}
.address-form label {
font-weight: bold;
}

Backend API
<dx-data-grid
id="gridContainer"
[dataSource]="suppliersData"
[remoteOperations]="true"
[showBorders]="true"
>
<dxo-data-grid-paging [pageSize]="15"></dxo-data-grid-paging>
<dxo-data-grid-pager [visible]="true"></dxo-data-grid-pager>
<dxi-data-grid-column dataField="ContactName"></dxi-data-grid-column>
<dxi-data-grid-column dataField="ContactTitle"></dxi-data-grid-column>
<dxi-data-grid-column dataField="CompanyName"></dxi-data-grid-column>
<dxi-data-grid-column dataField="City"></dxi-data-grid-column>
<dxi-data-grid-column dataField="Country"></dxi-data-grid-column>
<dxo-data-grid-master-detail
[enabled]="true"
template="masterDetail"
></dxo-data-grid-master-detail>
<div *dxTemplate="let masterDetailItem of 'masterDetail'">
<detail-view
[key]="masterDetailItem.key"
[rowData]="masterDetailItem.data"
></detail-view>
</div>
</dx-data-grid>
import { bootstrapApplication } from '@angular/platform-browser';
import { Component, enableProdMode, provideZoneChangeDetection } from '@angular/core';
import {
DxDataGridModule, DxFormModule, DxSelectBoxModule, DxTabPanelModule,
} from 'devextreme-angular';
import * as AspNetData from 'devextreme-aspnet-data-nojquery';
import { DataSource } from 'devextreme-angular/common/data';
import { DetailViewComponent } from './detail-view/detail-view.component';
if (!/localhost/.test(document.location.host)) {
enableProdMode();
}
let modulePrefix = '';
// @ts-ignore
if (window && window.config?.packageConfigPaths) {
modulePrefix = '/app';
}
@Component({
selector: 'demo-app',
templateUrl: `app/app.component.html`,
styleUrls: [`app/app.component.css`],
imports: [
DxDataGridModule,
DxFormModule,
DxSelectBoxModule,
DxTabPanelModule,
DetailViewComponent,
],
})
export class AppComponent {
url = 'https://js.devexpress.com/Demos/NetCore/api/DataGridAdvancedMasterDetailView';
suppliersData: DataSource;
constructor() {
this.suppliersData = new DataSource({
store: AspNetData.createStore({
key: 'SupplierID',
loadUrl: `${this.url}/GetSuppliers`,
}),
});
}
}
bootstrapApplication(AppComponent, {
providers: [
provideZoneChangeDetection({ eventCoalescing: true, runCoalescing: true }),
],
});
::ng-deep #gridContainer {
height: 620px;
}
::ng-deep .dx-datagrid-rowsview .dx-master-detail-row:not(.dx-datagrid-edit-form) > .dx-datagrid-group-space,
::ng-deep .dx-datagrid-rowsview .dx-master-detail-row:not(.dx-datagrid-edit-form) .dx-master-detail-cell {
background-color: transparent;
}
// In real applications, you should not transpile code in the browser.
// You can see how to create your own application with Angular and DevExtreme here:
// https://js.devexpress.com/Documentation/Guide/Angular_Components/Getting_Started/Create_a_DevExtreme_Application/
const componentNames = [
'accordion',
'action-sheet',
'autocomplete',
'bar-gauge',
'box',
'bullet',
'button-group',
'button',
'calendar',
'card-view',
'chart',
'chat',
'check-box',
'circular-gauge',
'color-box',
'context-menu',
'data-grid',
'date-box',
'date-range-box',
'defer-rendering',
'diagram',
'draggable',
'drawer',
'drop-down-box',
'drop-down-button',
'file-manager',
'file-uploader',
'filter-builder',
'form',
'funnel',
'gallery',
'gantt',
'html-editor',
'linear-gauge',
'list',
'load-indicator',
'load-panel',
'lookup',
'map',
'menu',
'multi-view',
'nested',
'number-box',
'pagination',
'pie-chart',
'pivot-grid-field-chooser',
'pivot-grid',
'polar-chart',
'popover',
'popup',
'progress-bar',
'radio-group',
'range-selector',
'range-slider',
'recurrence-editor',
'resizable',
'responsive-box',
'sankey',
'scheduler',
'scroll-view',
'select-box',
'slider',
'sortable',
'sparkline',
'speech-to-text',
'speed-dial-action',
'splitter',
'stepper',
'switch',
'tab-panel',
'tabs',
'tag-box',
'text-area',
'text-box',
'tile-view',
'toast',
'toolbar',
'tooltip',
'tree-list',
'tree-map',
'tree-view',
'validation-group',
'validation-summary',
'validator',
'vector-map',
];
window.exports = window.exports || {};
window.config = {
transpiler: false,
meta: {
'*.ts': {
loader: 'demo-ts-loader',
},
'typescript': {
'exports': 'ts',
},
'anti-forgery': {
loader: 'demo-ts-loader',
},
'devextreme-aspnet-data-nojquery': {
'esModule': true,
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'@angular/platform-browser-dynamic': {
'esModule': true,
},
'@angular/platform-browser': {
'esModule': true,
},
'@angular/core': {
'esModule': true,
},
'@angular/common': {
'esModule': true,
},
'@angular/common/http': {
'esModule': true,
},
'@angular/animations': {
'esModule': true,
},
'@angular/forms': {
'esModule': true,
},
'openai': {
'esModule': true,
},
'zod': {
'esModule': true,
},
'zod-to-json-schema': {
'esModule': true,
},
},
paths: {
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
'loaders:': '../../../../shared/loaders/',
},
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'demo-ts-loader': 'loaders:demo-ts-loader.js',
'demo-ts-shared': 'loaders:demo-ts-shared.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
/* @angular */
'@angular/compiler': 'bundles:@angular/compiler.umd.js',
'@angular/platform-browser-dynamic': 'bundles:@angular/platform-browser-dynamic.umd.js',
'@angular/core': 'bundles:@angular/core.umd.js',
'@angular/core/primitives/signals': 'bundles:@angular/core.primitives.signals.umd.js',
'@angular/core/primitives/di': 'bundles:@angular/core.primitives.di.umd.js',
'@angular/common': 'bundles:@angular/common.umd.js',
'@angular/common/http': 'bundles:@angular/common-http.umd.js',
'@angular/platform-browser': 'bundles:@angular/platform-browser.umd.js',
'@angular/platform-browser/animations': 'bundles:@angular/platform-browser.umd.js',
'@angular/forms': 'bundles:@angular/forms.umd.js',
/* devextreme */
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-quill': 'npm:devextreme-quill@1.7.10/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.69',
/* devextreme-angular umd maps */
'devextreme-angular': 'bundles:devextreme-angular/devextreme-angular.umd.js',
'devextreme-angular/common/ai-integration': 'bundles:devextreme-angular/devextreme-angular-common-ai-integration.umd.js',
'devextreme-angular/core': 'bundles:devextreme-angular/devextreme-angular-core.umd.js',
'devextreme-angular/common/charts': 'bundles:devextreme-angular/devextreme-angular-common-charts.umd.js',
'devextreme-angular/common/core/animation': 'bundles:devextreme-angular/devextreme-angular-common-core-animation.umd.js',
'devextreme-angular/common/core/environment': 'bundles:devextreme-angular/devextreme-angular-common-core-environment.umd.js',
'devextreme-angular/common/core/events': 'bundles:devextreme-angular/devextreme-angular-common-core-events.umd.js',
'devextreme-angular/common/core/localization': 'bundles:devextreme-angular/devextreme-angular-common-core-localization.umd.js',
'devextreme-angular/common/core': 'bundles:devextreme-angular/devextreme-angular-common-core.umd.js',
'devextreme-angular/common/data/custom-store': 'bundles:devextreme-angular/devextreme-angular-common-data-custom-store.umd.js',
'devextreme-angular/common/data': 'bundles:devextreme-angular/devextreme-angular-common-data.umd.js',
'devextreme-angular/common/export/excel': 'bundles:devextreme-angular/devextreme-angular-common-export-excel.umd.js',
'devextreme-angular/common/export/pdf': 'bundles:devextreme-angular/devextreme-angular-common-export-pdf.umd.js',
'devextreme-angular/common/export': 'bundles:devextreme-angular/devextreme-angular-common-export.umd.js',
'devextreme-angular/common/grids': 'bundles:devextreme-angular/devextreme-angular-common-grids.umd.js',
'devextreme-angular/common': 'bundles:devextreme-angular/devextreme-angular-common.umd.js',
'devextreme-angular/http': 'bundles:devextreme-angular/devextreme-angular-http.umd.js',
'devextreme-angular/core/tokens': 'bundles:devextreme-angular/devextreme-angular-core-tokens.umd.js',
...componentNames.reduce((acc, name) => {
acc[`devextreme-angular/ui/${name}`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}.umd.js`;
acc[`devextreme-angular/ui/${name}/nested`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}-nested.umd.js`;
return acc;
}, {}),
'zod': 'externals:zod.bundle.js',
'zod-to-json-schema': 'externals:zod-to-json-schema.bundle.js',
'tslib': 'npm:tslib/tslib.js',
'rxjs': 'npm:rxjs@7.5.3/dist/bundles/rxjs.umd.js',
'rxjs/operators': 'npm:rxjs@7.5.3/dist/cjs/operators/index.js',
'devextreme-aspnet-data-nojquery': 'npm:devextreme-aspnet-data-nojquery@5.1.0/index.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.4/dist/signals-core.min.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
'zone.js': 'npm:zone.js@0.16.2/bundles/zone.umd.js',
},
packages: {
'app': {
main: './app.component.ts',
defaultExtension: 'ts',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
'rxjs': {
defaultExtension: 'js',
},
'rxjs/operators': {
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
'npm:rxjs@7.5.3/package.json',
'npm:rxjs@7.5.3/operators/package.json',
'npm:devexpress-diagram@2.2.29/package.json',
'npm:devexpress-gantt@4.1.69/package.json',
],
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line no-console
// System.import('@angular/compiler').catch(console.error.bind(console));
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"zod": {
"version": "3.24.4"
},
"zod-to-json-schema": {
"version": "3.24.6"
},
"@angular/core": {
"version": "22.1.0"
},
"core-js": {
"version": "2.6.12"
},
"typescript": {
"version": "6.0.3"
},
"zone.js": {
"version": "0.16.2"
}
};
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.4/css/dx.light.css" />
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/zone.js@0.16.2/bundles/zone.umd.js"></script>
<script src="https://cdn.jsdelivr.net/npm/reflect-metadata@0.1.13/Reflect.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script src="config.js"></script>
<script>
System.import("app").catch(console.error.bind(console));
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<demo-app>Loading...</demo-app>
</div>
</body>
</html>
::ng-deep .form-container {
padding: 20px;
}
::ng-deep .address-form label {
font-weight: bold;
}
<dx-tab-panel>
<dxi-tab-panel-item title="Orders" template="ordersTab"></dxi-tab-panel-item>
<div *dxTemplate="let ordersTabItem of 'ordersTab'">
<dx-form labelLocation="top" class="form-container">
<dxi-form-item template="productSelectBox">
<dxo-form-label text="Product"></dxo-form-label>
</dxi-form-item>
<div *dxTemplate="let selectBoxItem of 'productSelectBox'">
<dx-select-box
[value]="productIdBySupplier"
[dataSource]="productsData"
[inputAttr]="{ 'aria-label': 'Product' }"
[deferRendering]="false"
valueExpr="ProductID"
displayExpr="ProductName"
(onValueChanged)="handleValueChange($event)"
>
</dx-select-box>
</div>
<dxi-form-item template="orderHistory">
<dxo-form-label text="Order History"></dxo-form-label>
</dxi-form-item>
<div *dxTemplate="let order of 'orderHistory'">
<dx-data-grid [dataSource]="orderHistoryData" [showBorders]="true">
<dxo-data-grid-paging [pageSize]="5"></dxo-data-grid-paging>
<dxi-data-grid-column dataField="OrderID"></dxi-data-grid-column>
<dxi-data-grid-column
dataField="OrderDate"
dataType="date"
></dxi-data-grid-column>
<dxi-data-grid-column dataField="ShipCountry"></dxi-data-grid-column>
<dxi-data-grid-column dataField="ShipCity"></dxi-data-grid-column>
<dxi-data-grid-column
dataField="UnitPrice"
format="currency"
></dxi-data-grid-column>
<dxi-data-grid-column dataField="Quantity"></dxi-data-grid-column>
<dxi-data-grid-column
dataField="Discount"
format="percent"
></dxi-data-grid-column>
<dxo-data-grid-summary>
<dxi-data-grid-total-item column="UnitPrice" summaryType="sum">
<dxo-data-grid-value-format
format="currency"
[precision]="2"
></dxo-data-grid-value-format>
</dxi-data-grid-total-item>
<dxi-data-grid-total-item
column="Quantity"
summaryType="count"
></dxi-data-grid-total-item>
</dxo-data-grid-summary>
</dx-data-grid>
</div>
</dx-form>
</div>
<dxi-tab-panel-item
title="Address"
template="addressTab"
></dxi-tab-panel-item>
<div *dxTemplate="let addressTabItem of 'addressTab'">
<dx-form
[formData]="rowData"
[colCount]="2"
[customizeItem]="customizeItemTemplate"
class="address-form form-container"
>
<dxi-form-item dataField="Address"></dxi-form-item>
<dxi-form-item dataField="City"></dxi-form-item>
<dxi-form-item dataField="Region"></dxi-form-item>
<dxi-form-item dataField="PostalCode"></dxi-form-item>
<dxi-form-item dataField="Country"></dxi-form-item>
<dxi-form-item dataField="Phone"></dxi-form-item>
<div *dxTemplate="let item of 'formItem'">
<span>{{ item.editorOptions.value }}</span>
</div>
</dx-form>
</div>
</dx-tab-panel>
import { Component, Input, AfterViewInit, ChangeDetectorRef } from '@angular/core';
import { DataSource } from 'devextreme-angular/common/data';
import * as AspNetData from 'devextreme-aspnet-data-nojquery';
import { DxFormModule, DxDataGridModule, DxSelectBoxModule, DxTabPanelModule } from 'devextreme-angular';
import { DxFormTypes } from 'devextreme-angular/ui/form';
import { DxSelectBoxTypes } from 'devextreme-angular/ui/select-box';
let modulePrefix = '';
// @ts-ignore
if (window && window.config?.packageConfigPaths) {
modulePrefix = '/app';
}
@Component({
selector: 'detail-view',
templateUrl: `app/detail-view/detail-view.component.html`,
styleUrls: [`app/detail-view/detail-view.component.css`],
imports: [
DxDataGridModule,
DxFormModule,
DxSelectBoxModule,
DxTabPanelModule,
],
})
export class DetailViewComponent implements AfterViewInit {
@Input() key: number;
@Input() rowData: object;
url: string;
productIdBySupplier: number;
productsData: DataSource;
orderHistoryData: DataSource;
constructor(private changeDetectorRef: ChangeDetectorRef) {
this.url = 'https://js.devexpress.com/Demos/NetCore/api/DataGridAdvancedMasterDetailView';
}
ngAfterViewInit() {
this.productsData = new DataSource({
store: AspNetData.createStore({
key: 'ProductID',
loadParams: { SupplierID: this.key },
loadUrl: `${this.url}/GetProductsBySupplier`,
onLoaded: (items) => this.setDefaultProduct(items),
}),
});
this.changeDetectorRef.detectChanges();
}
setDefaultProduct(items) {
const firstItem = items[0];
if (firstItem && this.productIdBySupplier === undefined) {
this.productIdBySupplier = firstItem.ProductID;
}
this.changeDetectorRef.detectChanges();
}
handleValueChange(e: DxSelectBoxTypes.ValueChangedEvent) {
this.productIdBySupplier = e.value;
this.orderHistoryData = new DataSource({
store: AspNetData.createStore({
key: 'OrderID',
loadParams: { ProductID: e.value },
loadUrl: `${this.url}/GetOrdersByProduct`,
}),
});
}
customizeItemTemplate(item: DxFormTypes.SimpleItem) {
item.template = 'formItem';
}
}

Backend API
<template>
<DxDataGrid
id="gridContainer"
:data-source="suppliersData"
:remote-operations="true"
:show-borders="true"
>
<DxPaging :page-size="15"/>
<DxPager :visible="true"/>
<DxColumn data-field="ContactName"/>
<DxColumn data-field="ContactTitle"/>
<DxColumn data-field="CompanyName"/>
<DxColumn data-field="City"/>
<DxColumn data-field="Country"/>
<DxMasterDetail
:enabled="true"
template="master-detail"
/>
<template #master-detail="{ data }">
<MasterDetail :master-detail-data="data"/>
</template>
</DxDataGrid>
</template>
<script setup lang="ts">
import {
DxDataGrid,
DxColumn,
DxPaging,
DxPager,
DxMasterDetail,
} from 'devextreme-vue/data-grid';
import { createStore } from 'devextreme-aspnet-data-nojquery';
import MasterDetail from './MasterDetail.vue';
const url = 'https://js.devexpress.com/Demos/NetCore/api/DataGridAdvancedMasterDetailView';
const suppliersData = createStore({
key: 'SupplierID',
loadUrl: `${url}/GetSuppliers`,
});
</script>
<template>
<DxForm
:form-data="data"
:items="items"
:col-count="2"
:customize-item="customizeItem"
class="address-form form-container"
>
<template #form-item="{ data: item }">
<span>
{{ item.editorOptions.value }}
</span>
</template>
</DxForm>
</template>
<script setup lang="ts">
import { DxForm, type DxFormTypes } from 'devextreme-vue/form';
import { type Supplier } from './data.ts';
defineProps<{
data: Supplier
}>();
const items = [
{ dataField: 'Address' },
{ dataField: 'City' },
{ dataField: 'Region' },
{ dataField: 'PostalCode' },
{ dataField: 'Country' },
{ dataField: 'Phone' },
];
const customizeItem = (item: DxFormTypes.SimpleItem) => {
item.template = 'form-item';
};
</script>
<template>
<DxTabPanel>
<DxItem
title="Orders"
template="orders-tab"
/>
<template #orders-tab>
<OrdersTab
:supplier-id="masterDetailData.key"
/>
</template>
<DxItem
title="Address"
template="address-tab"
/>
<template #address-tab>
<AddressTab
:data="masterDetailData.data"
/>
</template>
</DxTabPanel>
</template>
<script setup lang="ts">
import { DxTabPanel, DxItem } from 'devextreme-vue/tab-panel';
import OrdersTab from './OrdersTab.vue';
import AddressTab from './AddressTab.vue';
import { type Supplier } from './data.ts';
defineProps<{
masterDetailData: {
key: number,
data: Supplier
}
}>();
</script>
<template>
<div>
<DxDataGrid
:data-source="orderHistoryStore"
:show-borders="true"
>
<DxPaging :page-size="5"/>
<DxColumn data-field="OrderID"/>
<DxColumn
data-field="OrderDate"
data-type="date"
/>
<DxColumn data-field="ShipCountry"/>
<DxColumn data-field="ShipCity"/>
<DxColumn
data-field="UnitPrice"
format="currency"
/>
<DxColumn data-field="Quantity"/>
<DxColumn
data-field="Discount"
format="percent"
/>
<DxSummary>
<DxTotalItem
column="UnitPrice"
summary-type="sum"
>
<DxValueFormat
:precision="2"
format="currency"
/>
</DxTotalItem>
<DxTotalItem
column="Quantity"
summary-type="count"
/>
</DxSummary>
</DxDataGrid>
</div>
</template>
<script setup lang="ts">
import {
DxDataGrid, DxColumn, DxPaging, DxSummary, DxTotalItem, DxValueFormat,
} from 'devextreme-vue/data-grid';
import { createStore } from 'devextreme-aspnet-data-nojquery';
import { computed } from 'vue';
const props = defineProps<{
productId: number | null
}>();
const url = 'https://js.devexpress.com/Demos/NetCore/api/DataGridAdvancedMasterDetailView';
const orderHistoryStore = computed(() => (props.productId === null ? undefined : {
store: createStore({
key: 'OrderID',
loadParams: { ProductID: props.productId },
loadUrl: `${url}/GetOrdersByProduct`,
}),
}));
</script>
<template>
<DxForm
label-location="top"
class="form-container"
>
<DxItem template="select-box">
<DxLabel text="Product"/>
</DxItem>
<template #select-box>
<ProductSelectBox
:supplier-id="supplierId"
@product-changed="chosenProductId = $event"
/>
</template>
<DxItem template="order-history">
<DxLabel text="Order History"/>
</DxItem>
<template #order-history>
<OrderHistory
:product-id="chosenProductId"
/>
</template>
</DxForm>
</template>
<script setup lang="ts">
import { ref } from 'vue';
import { DxForm, DxItem, DxLabel } from 'devextreme-vue/form';
import ProductSelectBox from './ProductSelectBox.vue';
import OrderHistory from './OrderHistory.vue';
defineProps<{
supplierId: number
}>();
const chosenProductId = ref<null | number>(null);
</script>
<template>
<DxSelectBox
:defer-rendering="false"
:data-source="dataSource"
:input-attr="{ 'aria-label': 'Product' }"
:value="productId"
value-expr="ProductID"
display-expr="ProductName"
@valueChanged="$emit('product-changed', $event.value)"
/>
</template>
<script setup lang="ts">
import { ref } from 'vue';
import DxSelectBox from 'devextreme-vue/select-box';
import { createStore } from 'devextreme-aspnet-data-nojquery';
import { type Product } from './data.ts';
defineEmits(['product-changed']);
const props = defineProps<{
supplierId: number
}>();
const url = 'https://js.devexpress.com/Demos/NetCore/api/DataGridAdvancedMasterDetailView';
const dataSource = createStore({
key: 'ProductID',
loadParams: { SupplierID: props.supplierId },
loadUrl: `${url}/GetProductsBySupplier`,
onLoaded: setDefaultValue,
});
const productId = ref<number>();
function setDefaultValue(items: Product[]) {
const firstItem = items[0];
if (firstItem && productId.value === undefined) {
productId.value = firstItem.ProductID;
}
}
</script>
window.exports = window.exports || {};
window.config = {
transpiler: false,
meta: {
'*.vue': {
loader: 'vue-loader',
},
'*.ts': {
loader: 'demo-ts-loader',
},
'*.svg': {
loader: 'svg-loader',
},
'typescript': {
'exports': 'ts',
},
'vue': {
format: 'global',
exports: 'Vue',
esModule: true,
},
'vuex': {
format: 'global',
exports: 'Vuex',
esModule: true,
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'devextreme-aspnet-data-nojquery': {
'esModule': true,
},
'openai': {
'esModule': true,
},
'zod': {
'esModule': true,
},
'zod-to-json-schema': {
'esModule': true,
},
'anti-forgery': {
loader: 'demo-ts-loader',
},
},
paths: {
'project:': '../../../../',
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
'loaders:': '../../../../shared/loaders/',
},
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'vue': 'npm:vue@3.5.40/dist/vue.global.js',
'@vue/shared': 'npm:@vue/shared@3.4.26/dist/shared.cjs.prod.js',
'dx-systemjs-vue-browser': 'npm:dx-systemjs-vue-browser@1.1.2/index.js',
'demo-ts-loader': 'loaders:demo-ts-loader.js',
'demo-ts-shared': 'loaders:demo-ts-shared.js',
'vue-loader': 'loaders:demo-vue-loader.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
'svg-loader': 'project:utils/svg-loader.js',
'devextreme-aspnet-data-nojquery': 'npm:devextreme-aspnet-data-nojquery@5.1.0/index.js',
'mitt': 'npm:mitt/dist/mitt.umd.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-vue': 'npm:devextreme-vue@link:../../packages/devextreme-vue/npm/cjs',
'zod': 'externals:zod.bundle.js',
'zod-to-json-schema': 'externals:zod-to-json-schema.bundle.js',
'devextreme-quill': 'npm:devextreme-quill@1.7.10/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.69/dist/dx-gantt.js',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.4/dist/signals-core.min.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
},
packages: {
'devextreme-vue': {
main: 'index.js',
},
'devextreme-vue/common': {
main: 'index.js',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
],
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"zod": {
"version": "3.24.4"
},
"zod-to-json-schema": {
"version": "3.24.6"
}
};
export type Supplier = {
SupplierID: number;
CompanyName: string;
ContactName: string;
ContactTitle: string;
Address: string;
City: string;
Region: string | null;
PostalCode: string;
Country: string;
Phone: string;
Fax: string | null;
HomePage: string | null;
};
export type Product = {
ProductID: number;
ProductName: string
SupplierID: number;
CategoryID: number;
QuantityPerUnit: string
UnitPrice: number
UnitsInStock: number
UnitsOnOrder: number
ReorderLevel: number
Discontinued: boolean;
};
export type Order = {
OrderID: number;
OrderDate: Date;
ShipCountry: string;
ShipCity: string;
UnitPrice: number;
Quantity: number;
Discount: number;
};
import { createApp } from 'vue';
import App from './App.vue';
createApp(App).mount('#app');
#gridContainer {
height: 620px;
}
.dx-datagrid-rowsview .dx-master-detail-row:not(.dx-datagrid-edit-form) > .dx-datagrid-group-space,
.dx-datagrid-rowsview .dx-master-detail-row:not(.dx-datagrid-edit-form) .dx-master-detail-cell {
background-color: transparent;
}
.form-container {
padding: 20px;
}
.address-form label {
font-weight: bold;
}
<!DOCTYPE html>
<html lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.4/css/dx.light.css" />
<link rel="stylesheet" type="text/css" href="styles.css" />
<script type="module">
import * as vueCompilerSFC from "https://cdn.jsdelivr.net/npm/@vue/compiler-sfc@3.4.27/dist/compiler-sfc.esm-browser.js";
window.vueCompilerSFC = vueCompilerSFC;
</script>
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.ts");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app" />
</div>
</body>
</html>